<template>
  <form action="post" @submit.prevent="login" autocomplete="off">
    <div class="p-8 px-12">
      <!-- start: form header -->
      <h1 class="text-2xl text-center font-semibold mb-2">Sign In</h1>
      <p class="text-center mb-8">Masukkan email dan password anda</p>
      <!-- end: form header -->

      <!-- start: form input -->
      <form-input
        class="mb-4"
        :id="'email'"
        :label="'Email'"
        :type="'email'"
        v-model="email"
        :error="errorEmail"
      />
      <form-input
        class="mb-4"
        :id="'password'"
        :label="'Password'"
        :type="'password'"
        v-model="password"
        :error="errorPassword"
        :passwordToggle="true"
      />
      <!-- end: form input -->

      <div class="flex mb-4 justify-between items-center">
        <!-- start: remember me -->
        <div class="flex items-center">
          <input type="checkbox" class="form-checkbox text-data-blue" id="remember" v-model="remember" />
          <label for="remember" class="cursor-pointer text-sm ml-2">
            Stay signed in
          </label>
        </div>
        <!-- end: remember me -->

        <!-- start: lupa password -->
        <span class="cursor-pointer text-sm text-data-blue font-semibold">
          Lupa Password?
        </span>
        <!-- end: lupa password -->
      </div>

      <button
        class="text-semibold bg-data-blue py-2 mb-4 rounded-sm w-full"
        type="submit"
      >
        Masuk
      </button>

      <!-- start: register -->
      <div class="text-center text-ui-400 text-sm">
        Belum punya akun?
        <nuxt-link to="/register" class="font-semibold text-white">
          Daftar Sekarang
        </nuxt-link>
      </div>
      <!-- end: register -->
    </div>
  </form>
</template>

<script>
import { mapState } from 'vuex';
import FormInput from '~/components/FormInput.vue';

export default {
  layout: 'login',

  components: {
    FormInput,
  },

  data: () => ({
    email: '',
    password: '',
    remember: false,
    check: false,

    errorEmail: '',
    errorPassword: '',
  }),

  computed: {
    ...mapState({
      token: 'auth/token',
      serverErrorEmail: 'auth/errorEmail',
      serverErrorPassword: 'auth/errorPassword',
    }),
  },

  methods: {
    login: function() {
      this.$store.dispatch(
        'auth/login',
        { email: this.email, password: this.password },
      );

      if (this.token) {
        // redirect
      } else {
        this.errorEmail = serverErrorEmail;
        this.errorPassword = serverErrorPassword;
      }
    },
  },
};
</script>

<style lang="postcss" scoped>
</style>
